--- /dev/null	Sun Aug  5 23:41:10 2018
+++ new/usr/src/man/man3c/sockaddr.3c	Sun Aug  5 23:41:10 2018
@@ -0,0 +1,534 @@
+.\"
+.\" This file and its contents are supplied under the terms of the
+.\" Common Development and Distribution License ("CDDL"), version 1.0.
+.\" You may only use this file in accordance with the terms of version
+.\" 1.0 of the CDDL.
+.\"
+.\" A full copy of the text of the CDDL should have accompanied this
+.\" source.  A copy of the CDDL is also available via the Internet at
+.\" http://www.illumos.org/license/CDDL.
+.\"
+.\"
+.\" Copyright 2015, Joyent, Inc.
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt SOCKADDR 3C
+.Os
+.Sh NAME
+.Nm sockaddr ,
+.Nm sockaddr_dl ,
+.Nm sockaddr_in ,
+.Nm sockaddr_in6 ,
+.Nm sockaddr_ll ,
+.Nm sockaddr_storage ,
+.Nm sockaddr_un
+.Nd Socket Address Structures
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/socket.h
+.Vt struct sockaddr sock;
+.In sys/socket.h
+.In net/if_dl.h
+.Vt struct sockaddr_dl dl_sock;
+.In sys/socket.h
+.In netinet/in.h
+.Vt struct sockaddr_in in_sock;
+.In sys/socket.h
+.In netinet/in.h
+.Vt struct sockaddr_in6 in6_sock;
+.In sys/socket.h
+.Vt struct sockaddr_ll ll_sock;
+.In sys/socket.h
+.Vt struct sockaddr_storage storage_sock;
+.In sys/un.h
+.Vt struct sockaddr_un un_sock;
+.Sh DESCRIPTION
+The
+.Nm
+family of structures are designed to represent network addresses for
+different networking protocols.
+The structure
+.Vt struct sockaddr
+is a generic structure that is used across calls to various socket routines such
+as
+.Xr accept 3C
+and
+.Xr bind 3C .
+Applications do not use the
+.Vt struct sockaddr
+directly, but instead cast the appropriate networking family specific
+.Nm
+structure to a
+.Vt struct sockaddr * .
+.Pp
+Every structure in the
+.Nm
+family begins with a member of the same type, the
+.Vt sa_family_t ,
+though the different structures all have different names for the member.
+For example, the structure
+.Vt struct sockaddr
+has the following members defined:
+.Bd -literal -offset indent
+sa_family_t	sa_family	/* address family */
+char		sa_data[]	/* socket address (variable-length data) */
+.Ed
+.Pp
+The member
+.Va sa_family
+corresponds to the socket family that's actually in use.
+The following table describes the mapping between the address family and the
+corresponding socket structure that's used.
+Note that both the generic
+.Vt struct sockaddr
+and the
+.Vt struct sockaddr_storage
+are not included, because these are both generic structures.
+More on the
+.Vt struct sockaddr_storage
+can be found in the next section.
+.Bl -column -offset indent ".Sy Socket Structure" ".Sy Address Family"
+.It Sy Socket Structure Ta Sy Address Family
+.It Vt struct sockaddr_dl Ta Dv AF_LINK
+.It Vt struct sockaddr_in Ta Dv AF_INET
+.It Vt struct sockaddr_in6 Ta Dv AF_INET6
+.It Vt struct sockaddr_ll Ta Dv AF_PACKET
+.It Vt struct sockaddr_un Ta Dv AF_UNIX
+.El
+.Ss struct sockaddr_storage
+The
+.Vt sockaddr_storage
+structure is a
+.Nm
+that is not associated with an address family.
+Instead, it is large enough to hold the contents of any of the other
+.Nm
+structures.
+It can be used to embed sufficient storage for a
+.Vt sockaddr
+of any type within a larger structure.
+.Pp
+The structure only has a single member defined.
+While there are other members that are used to pad out the size of the
+.Vt struct sockaddr_storage ,
+they are not defined and must not be consumed.
+The only valid member is:
+.Bd -literal -offset indent
+sa_family_t	ss_family	/* address family */
+.Ed
+.Pp
+For example,
+.Vt struct sockaddr_storage
+is useful when running a service that accepts traffic over both IPv4 and IPv6
+where it is common to use a single socket for both address families.
+In that case, rather than guessing whether a
+.Vt struct sockaddr_in
+or a
+.Vt struct sockaddr_in6
+is more appropriate, one can simply use a
+.Vt struct sockaddr_storage
+and cast to the appropriate family-specific structure type based on the
+value of the member
+.Va ss_family .
+.Ss struct sockaddr_in
+The
+.Vt sockaddr_in
+is the socket type which is used for for the Internet Protocol version
+four (IPv4).
+It has the following members defined:
+.Bd -literal -offset indent
+sa_family_t	sin_family	/* address family */
+in_port_t	sin_port	/* IP port */
+struct in_addr	sin_addr	/* IP address */
+.Ed
+.Pp
+The member
+.Va sin_family
+must always have the value
+.Dv AF_INET
+for IPv4 .
+The members
+.Va sin_port
+and
+.Va sin_addr
+describe the IP address and IP port to use.
+In the case of a call to
+.Xr connect 3C
+these represent the remote IP address and port to which the connection
+is being made.
+In the case of
+.Xr bind 3C
+these represent the IP address and port on the local host to which the socket
+is to be bound.
+In the case of
+.Xr accept 3C
+these represent the remote IP address and port of the machine whose connection
+was accepted.
+.Pp
+The member
+.Va sin_port
+is always stored in network byte order.
+On many systems, this differs from the native host byte order.
+Applications should read from the member with the function
+.Xr ntohs 3C
+and write to the member with the function
+.Xr htons 3C .
+The member
+.Va sin_addr
+is the four byte IPv4 address.
+It is also stored in network byte order.
+The common way to write out the address is to use the function
+.Xr inet_pton 3C
+which converts between a human readable IP address such as
+.Ql 10.1.2.3
+and the corresponding representation.
+.Pp
+Example 1 shows how to prepare an IPv4 socket and deal with
+network byte-order.
+See
+.Xr inet 7P
+and
+.Xr ip 7P
+for more information on IPv4, socket options, etc.
+.Ss struct sockaddr_in6
+The
+.Vt sockaddr_in6
+structure is the
+.Nm
+for the Internet Protocol version six (IPv6).
+Unlike the
+.Vt struct sockaddr_in ,
+the
+.Vt struct sockaddr_in6
+has additional members beyond those shown here which are required to be
+initialized to zero through a function such as
+.Xr bzero 3C
+or
+.Xr memset 3C .
+If the entire
+.Vt struct sockaddr_in6
+is not zeroed before use, applications will experience undefined behavior.
+The
+.Vt struct sockaddr_in6
+has the following public members:
+.Bd -literal -offset indent
+sa_family_t	sin6_family	/* address family */
+in_port_t	sin6_port	/* IPv6 port */
+struct in6_addr	sin6_addr	/* IPv6 address */
+uint32_t	sin6_flowinfo;	/* traffic class and flow info */
+uint32_t	sin6_scope_id;	/* interface scope */
+.Ed
+.Pp
+The member
+.Va sin6_family
+must always have the value
+.Dv AF_INET6 .
+The members
+.Va sin6_port
+and
+.Va sin6_addr
+are the IPv6 equivalents of the
+.Vt struct sockaddr_in
+.Va sin_port
+and
+.Va sin_addr .
+Like their IPv4 counterparts, both of these members must be in network
+byte order.
+The member
+.Va sin6_port
+describes the IPv6 port and should be manipulated with the functions
+.Xr ntohs 3C
+and
+.Xr htons 3C .
+The member
+.Va sin6_addr
+describes the 16-byte IPv6 address.
+In addition to the function
+.Xr inet_pton 3C ,
+the header file
+.In netinet/in.h
+defines many macros for manipulating and testing IPv6 addresses.
+.Pp
+The member
+.Va sin6_flowinfo
+contains the traffic class and flow label associated with the IPv6
+header.
+The member
+.Va sin6_scope_id
+may contain an identifier which varies based on the scope of the address in
+.Va sin6_addr .
+Applications do not need to initialize
+.Va sin6_scope_id ;
+it will be populated by the operating system as a result of various library
+calls.
+.Pp
+Example 2 shows how to prepare an IPv6 socket.
+For more information on IPv6, please see
+.Xr inet6 7P
+and
+.Xr ip6 7P .
+.Ss struct sockaddr_un
+The
+.Vt sockaddr_un
+structure specifies the address of a socket used to communicate between
+processes running on a single system, commonly known as a UNIX domain socket.
+Sockets of this type are identified by a path in the file system.
+The
+.Vt struct sockaddr_un
+has the following members:
+.Bd -literal -offset indent
+sa_family_t	sun_family	/* address family */
+char		sun_path[108]	/* path name */
+.Ed
+.Pp
+The member
+.Va sun_family
+must always have the value
+.Dv AF_UNIX .
+The member
+.Va sun_path
+is populated with a NUL terminated array of characters that specify a file
+system path.
+The maximum length of any such path, including the NUL terminator, is 108 bytes.
+.Ss struct sockaddr_dl
+The
+.Vt sockaddr_dl
+structure is used to describe a layer 2 link-level address.
+This is used as part of various socket ioctls, such as those for
+.Xr arp 7P .
+The structure has the following members:
+.Bd -literal -offset indent
+ushort_t	sdl_family;	/* address family */
+ushort_t	sdl_index;	/* if != 0, system interface index */
+uchar_t		sdl_type;	/* interface type */
+uchar_t		sdl_nlen;	/* interface name length */
+uchar_t		sdl_alen;	/* link level address length */
+uchar_t		sdl_slen;	/* link layer selector length */
+char		sdl_data[244];	/* contains both if name and ll address
+.Ed
+.Pp
+The member
+.Va sdl_family
+must always have the value
+.Dv AF_LINK .
+When the member
+.Va sdl_index
+is non-zero this refers to the interface identifier that corresponds to
+the
+.Vt struct sockaddr_dl .
+This identifier is the same identifier that's shown by tools like
+.Xr ifconfig 1M
+and used in the SIOC* set of socket ioctls.
+The member
+.Va sdl_type
+refers to the media that is used for the socket.
+The most common case is that the medium for the interface is Ethernet which has
+the value
+.Dv IFT_ETHER .
+The full set of types is derived from RFC1573 and recorded in the file
+.In net/if_types.h .
+The member
+.Va sdl_slen
+describes the length of a selector, if it exists, for the specified medium.
+This is used in protocols such as Trill.
+.Pp
+The
+.Va sdl_data ,
+.Va sdl_nlen ,
+and
+.Va sdl_alen
+members together describe a character string containing the interface name and
+the link-layer network address.
+The name starts at the beginning of
+.Va sdl_data ,
+i.e. at
+.Va sdl_data Ns Bq 0 .
+The name of the interface occupies the next
+.Va sdl_nlen
+bytes and is not NUL terminated.
+The link-layer network address begins immediately after the interface name,
+and is
+.Va sdl_alen
+bytes long.
+The macro
+.Dv LLADDR(struct sockaddr_dl *)
+returns the start of the link-layer network address.
+The interpretation of the link-layer address depends on the value of
+.Va sdl_type .
+For example, if the type is
+.Dv IFT_ETHER
+then the address is expressed as a 6-byte MAC address.
+.Ss struct sockaddr_ll
+The
+.Vt sockaddr_ll
+is used as part of a socket type which is responsible for packet capture:
+.Dv AF_PACKET
+sockets.
+It is generally designed for use with Ethernet networks.
+The members of the
+.Vt struct sockaddr_ll
+are:
+.Bd -literal -offset indent
+uint16_t        sll_family;	/* address family */
+uint16_t        sll_protocol;	/* link layer protocol */
+int32_t         sll_ifindex;	/* interface index */
+uint16_t        sll_hatype;	/* ARP hardware type */
+uint8_t         sll_pkttype;	/* packet type */
+uint8_t         sll_halen;	/* hardware address length */
+uint8_t         sll_addr[8];	/* hardware type */
+.Ed
+.Pp
+The member
+.Va sll_family
+must be
+.Dv AF_PACKET .
+The member
+.Va sll_protocol
+refers to a link-layer protocol.
+For example, when capturing Ethernet frames the value of
+.Va sll_protocol
+is the Ethertype.
+This member is written in network byte order and applications should use
+.Xr htons 3C
+and
+.Xr ntohs 3C
+to read and write the member.
+.Pp
+The member
+.Va sll_ifindex
+is the interface's index.
+It is used as an identifier in various ioctls and included in the output of
+.Xr ifconfig 1M .
+When calling
+.Xr bind 3C
+it should be filled in with the index that corresponds to the interface
+for which packets should be captured on.
+.Pp
+The member
+.Va sll_pkttype
+describes the type of the packet based on a list of types in the header file
+.In netpacket/packet.h .
+These types include:
+.Dv PACKET_OUTGOING ,
+a packet that was leaving the host and has been looped back for packet capture;
+.Dv PACKET_HOST ,
+a packet that was destined for this host;
+.Dv PACKET_BROADCAST ,
+a packet that was broadcast across the link-layer;
+.Dv PACKET_MULTICAST ,
+a packet that was sent to a link-layer multicast address; and
+.Dv PACKET_OTHERHOST ,
+a packet that was captured only because the device in question was in
+promiscuous mode.
+.Pp
+The member
+.Va sll_hatype
+contains the hardware type as defined by
+.Xr arp 7P .
+The list of types can be found in
+.In net/if_arp.h .
+The member
+.Va sll_halen
+contains the length, in bytes, of the hardware address, while the member
+.Va sll_addr
+contains the actual address in network byte order.
+.Sh EXAMPLES
+.Bl -tag -width Ds
+.It Sy Example 1 No Preparing an IPv4 sockaddr_in to connect to a remote host
+The following example shows how one would open a socket and prepare it
+to connect to the remote host whose address is the IP address 127.0.0.1
+on port 80.
+.Bd -literal
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <stdio.h>
+#include <netinet/in.h>
+#include <inttypes.h>
+#include <strings.h>
+
+int
+main(void)
+{
+	int sock;
+	struct sockaddr_in in;
+
+	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
+		perror("socket");
+		return (1);
+	}
+
+	bzero(&in, sizeof (struct sockaddr_in));
+	in.sin_family = AF_INET;
+	in.sin_port = htons(80);
+	if (inet_pton(AF_INET, "127.0.0.1", &in.sin_addr) != 1) {
+		perror("inet_pton");
+		return (1);
+	}
+
+	if (connect(sock, (struct sockaddr *)&in,
+	    sizeof (struct sockaddr_in)) != 0) {
+		perror("connect");
+		return (1);
+	}
+
+	/* use socket */
+
+	return (0);
+}
+.Ed
+.It Sy Example 2 No Preparing an IPv6 sockaddr_in6 to bind to a local address
+The following example shows how one would open a socket and prepare it
+to bind to the local IPv6 address ::1 port on port 12345.
+.Bd -literal
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <stdio.h>
+#include <netinet/in.h>
+#include <inttypes.h>
+#include <strings.h>
+
+int
+main(void)
+{
+	int sock6;
+	struct sockaddr_in6 in6;
+
+	if ((sock6 = socket(AF_INET6, SOCK_STREAM, 0)) < 0) {
+		perror("socket");
+		return (1);
+	}
+
+	bzero(&in6, sizeof (struct sockaddr_in6));
+	in6.sin6_family = AF_INET6;
+	in6.sin6_port = htons(12345);
+	if (inet_pton(AF_INET6, "::1", &in6.sin6_addr) != 1) {
+		perror("inet_pton");
+		return (1);
+	}
+
+	if (bind(sock6, (struct sockaddr *)&in6,
+	    sizeof (struct sockaddr_in6)) != 0) {
+		perror("bind");
+		return (1);
+	}
+
+	/* use server socket */
+
+	return (0);
+}
+.Ed
+.El
+.Sh SEE ALSO
+.Xr accept 3C ,
+.Xr bind 3C ,
+.Xr connect 3C ,
+.Xr socket 3C ,
+.Xr socket.h 3HEAD ,
+.Xr un.h 3HEAD ,
+.Xr arp 7P ,
+.Xr inet 7P ,
+.Xr inet6 7P ,
+.Xr ip 7P ,
+.Xr ip6 7P
--- /dev/null	Sun Aug  5 23:41:10 2018
+++ new/usr/src/man/man3c/socket.3c	Sun Aug  5 23:41:10 2018
@@ -0,0 +1,301 @@
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License (the "License").
+.\" You may not use this file except in compliance with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\"
+.\" Copyright 1989 AT&T
+.\" Copyright (C) 2009, Sun Microsystems, Inc. All Rights Reserved.
+.\" Copyright (c) 2013, OmniTI Computer Consulting, Inc. All Rights Reserved.
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt SOCKET 3C
+.Os
+.Sh NAME
+.Nm socket
+.Nd create an endpoint for communication
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/types.h
+.In sys/socket.h
+.Ft int
+.Fo socket
+.Fa "int domain"
+.Fa "int type"
+.Fa "int protocol"
+.Fc
+.Sh DESCRIPTION
+The
+.Fn socket
+function creates an endpoint for communication and returns a
+descriptor.
+.Pp
+The
+.Fa domain
+argument specifies the protocol family within which communication takes place.
+The protocol family is generally the same as the address family for the
+addresses supplied in later operations on the socket.
+These families are defined in
+.In sys/socket.h .
+.Pp
+The currently supported protocol families are:
+.Bl -tag -width "PF_INET6"
+.It Dv PF_UNIX
+UNIX system internal protocols
+.It Dv PF_INET
+Internet Protocol Version 4 (IPv4)
+.It Dv PF_INET6
+Internet Protocol Version 6 (IPv6)
+.It Dv PF_NCA
+Network Cache and Accelerator (NCA) protocols
+.El
+.Pp
+The socket has the indicated
+.Fa type ,
+which specifies the communication semantics.
+Currently defined types are:
+.Bl -tag -width Ds
+.It Dv SOCK_STREAM
+.It Dv SOCK_DGRAM
+.It Dv SOCK_RAW
+.It Dv SOCK_SEQPACKET
+.It Dv SOCK_RDM
+.El
+.Pp
+The
+.Fa type
+may be augmented by a bitwise-inclusive-OR of flags from the following list,
+defined in
+.In sys/socket.h :
+.Bl -tag -width Ds
+.It Dv SOCK_CLOEXEC
+Creates the socket with the
+.Dv FD_CLOEXEC
+flag set, causing the underlying file descriptor to be closed prior to any
+future calls to
+.Xr exec 2 .
+This is similar in purpose to the
+.Dv O_CLOEXEC
+flag to
+.Xr open 2 .
+.It Dv SOCK_NDELAY
+Creates the socket with the
+.Dv O_NDELAY
+flag set, causing the socket to provide nonblocking semantics as described for
+.Dv O_NDELAY
+in
+.Xr open 2 .
+.Dv SOCK_NONBLOCK
+should normally be used in preference to
+.Dv SOCK_NDELAY ,
+and takes precedence if both are set.
+See
+.Xr open 2
+for further details.
+.It Dv SOCK_NONBLOCK
+Creates the socket with the
+.Dv O_NONBLOCK
+flag set, causing the socket to provide nonblocking semantics as described for
+.Dv O_NONBLOCK
+in
+.Xr open 2 .
+.El
+.Pp
+There must be an entry in the
+.Xr netconfig 4
+file for at least each protocol family and type required.
+If a non-zero protocol has been specified but no exact match for the protocol
+family, type, and protocol is found, then the first entry containing the
+specified family and type with a
+.Fa protocol
+value of zero will be used.
+.Pp
+A
+.Dv SOCK_STREAM
+type provides sequenced, reliable, two-way connection-based byte streams.
+An out-of-band data transmission mechanism may be supported.
+A
+.Dv SOCK_DGRAM
+socket supports datagrams (connectionless, unreliable messages of a fixed
+(typically small) maximum length).
+A
+.Dv SOCK_SEQPACKET
+socket may provide a sequenced, reliable, two-way connection-based data
+transmission path for datagrams of fixed maximum length; a consumer may be
+required to read an entire packet with each read system call.
+This facility is protocol specific, and presently not implemented for any
+protocol family.
+.Dv SOCK_RAW
+sockets provide access to internal network interfaces.
+The types
+.Dv SOCK_RAW ,
+which is available only to a user with the
+.Em net_rawaccess
+privilege, and
+.Dv SOCK_RDM ,
+for which no implementation currently exists, are not described here.
+.Pp
+The
+.Fa protocol
+parameter is a protocol-family-specific value which specifies a particular
+protocol to be used with the socket.
+Normally this value is zero, as commonly only a single protocol exists to
+support a particular socket type within a given protocol family.
+However, multiple protocols may exist, in which case a particular protocol may
+be specified in this manner.
+.Pp
+Sockets of type
+.Dv SOCK_STREAM
+are full-duplex byte streams, similar to pipes.
+A stream socket must be in a "connected" state before any data may be sent or
+received on it.
+A connection to another socket is created with a
+.Xr connect 3C
+call.
+Once connected, data may be transferred using
+.Xr read 2
+and
+.Xr write 2
+calls or some variant of the
+.Xr send 3C
+and
+.Xr recv 3C
+calls.
+When a session has been completed, a
+.Xr close 2
+may be performed.
+Out-of-band data may also be transmitted as described on the
+.Xr send 3C
+manual page and received as described on the
+.Xr recv 3C
+manual page.
+.Pp
+The communications protocols used to implement a
+.Dv SOCK_STREAM
+insure that data is not lost or duplicated.
+If a piece of data for which the peer protocol has buffer space cannot be
+successfully transmitted within a reasonable length of time, then the connection
+is considered broken and calls will indicate an error with -1 returns and with
+.Er ETIMEDOUT
+as the specific code in the global variable
+.Va errno .
+The protocols optionally keep sockets "warm" by forcing transmissions roughly
+every minute in the absence of other activity.
+An error is then indicated if no response can be elicited on an otherwise idle
+connection for a extended period (for instance 5 minutes).
+A
+.Dv SIGPIPE
+signal is raised if a thread sends on a broken stream; this causes naive
+processes, which do not handle the signal, to exit.
+.Pp
+.Dv SOCK_SEQPACKET
+sockets employ the same system calls as
+.Dv SOCK_STREAM
+sockets.
+The only difference is that
+.Xr read 2
+calls will return only the amount of data requested, and any remaining in the
+arriving packet will be discarded.
+.Pp
+.Dv SOCK_DGRAM
+and
+.Dv SOCK_RAW
+sockets allow datagrams to be sent to correspondents named in
+.Xr sendto 3C
+calls.
+Datagrams are generally received with
+.Xr recvfrom 3C ,
+which returns the next datagram with its return address.
+.Pp
+An
+.Xr fcntl 2
+call can be used to specify a process group to receive a
+.Dv SIGURG
+signal when the out-of-band data arrives.
+It can also enable non-blocking I/O.
+.Pp
+The operation of sockets is controlled by socket level options.
+These options are defined in the file
+.In sys/socket.h .
+.Xr setsockopt 3C
+and
+.Xr getsockopt 3C
+are used to set and get options, respectively.
+.Sh RETURN VALUES
+Upon successful completion, a descriptor referencing the socket is returned.
+Otherwise, -1 is returned and
+.Va errno
+is set to indicate the error.
+.Sh ERRORS
+The
+.Fn socket
+function will fail if:
+.Bl -tag -width Er
+.It Bq Er EACCES
+Permission to create a socket of the specified type or protocol is denied.
+.It Bq Er EAGAIN
+There were insufficient resources available to complete the operation.
+.It Bq Er EAFNOSUPPORT
+The specified address family is not supported by the protocol family.
+.It Bq Er EMFILE
+The per-process descriptor table is full.
+.It Bq Er ENOMEM
+Insufficient user memory is available.
+.It Bq Er ENOSR
+There were insufficient STREAMS resources available to complete the operation.
+.It Bq Er EPFNOSUPPORT
+The specified protocol family is not supported.
+.It Bq Er EPROTONOSUPPORT
+The protocol type is not supported by the address family.
+.It Bq Er EPROTOTYPE
+The socket type is not supported by the protocol.
+.It Bq Er EINVAL
+One or more of the specified flags is not supported.
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr nca 1 ,
+.Xr close 2 ,
+.Xr exec 2 ,
+.Xr fcntl 2 ,
+.Xr ioctl 2 ,
+.Xr open 2 ,
+.Xr read 2 ,
+.Xr write 2 ,
+.Xr accept 3C ,
+.Xr bind 3C ,
+.Xr connect 3C ,
+.Xr getsockname 3C ,
+.Xr getsockopt 3C ,
+.Xr listen 3C ,
+.Xr recv 3C ,
+.Xr send 3C ,
+.Xr setsockopt 3C ,
+.Xr shutdown 3C ,
+.Xr socketpair 3C ,
+.Xr in.h 3HEAD ,
+.Xr socket.h 3HEAD ,
+.Xr attributes 5
+.Sh NOTES
+Historically,
+.Dv AF_ Ns *
+was commonly used in places where
+.Dv PF_ Ns *
+was meant.
+New code should be careful to use
+.Dv PF_ Ns *
+as necessary.
--- /dev/null	Sun Aug  5 23:41:10 2018
+++ new/usr/src/man/man3c/socketpair.3c	Sun Aug  5 23:41:10 2018
@@ -0,0 +1,87 @@
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License (the "License").
+.\" You may not use this file except in compliance with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\"
+.\" Copyright 1989 AT&T
+.\" Copyright (C) 2002, Sun Microsystems, Inc. All Rights Reserved
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt SOCKETPAIR 3C
+.Os
+.Sh NAME
+.Nm socketpair
+.Nd create a pair of connected sockets
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/types.h
+.In sys/socket.h
+.Ft int
+.Fo socketpair
+.Fa "int domain"
+.Fa "int type"
+.Fa "int protocol"
+.Fa "int sv[2]"
+.Fc
+.Sh DESCRIPTION
+The
+.Fn socketpair
+library call creates an unnamed pair of connected sockets in the specified
+address family
+.Fa domain ,
+of the specified
+.Fa type ,
+that uses the optionally specified
+.Fa protocol .
+The descriptors that are used in referencing the new sockets are returned in
+.Fa sv Ns Bq 0
+and
+.Fa sv Ns Bq 1 .
+The two sockets are indistinguishable.
+.Sh RETURN VALUES
+.Fn socketpair
+returns -1 on failure and 0 on success.
+.Sh ERRORS
+The call succeeds unless:
+.Bl -tag -width Er
+.It Bq Er EAFNOSUPPORT
+The specified address family is not supported on this machine.
+.It Bq Er EMFILE
+Too many descriptors are in use by this process.
+.It Bq Er ENOMEM
+There was insufficient user memory for the operation to complete.
+.It Bq Er ENOSR
+There were insufficient STREAMS resources for the operation to complete.
+.It Bq Er EOPNOTSUPP
+The specified protocol does not support creation of socket pairs.
+.It Bq Er EPROTONOSUPPORT
+The specified protocol is not supported on this machine.
+.It Bq Er EACCES
+The process does not have appropriate privileges.
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr pipe 2 ,
+.Xr read 2 ,
+.Xr write 2 ,
+.Xr socket.h 3HEAD ,
+.Xr attributes 5
+.Sh NOTES
+This call is currently implemented only for the
+.Dv AF_UNIX
+address family.
--- old/usr/src/man/man3socket/Makefile	Sun Aug  5 23:41:11 2018
+++ new/usr/src/man/man3socket/Makefile	Sun Aug  5 23:41:11 2018
@@ -19,28 +19,20 @@
 
 MANSECT=	3socket
 
-MANFILES=	accept.3socket		\
-		bind.3socket		\
-		byteorder.3socket	\
-		connect.3socket		\
+MANFILES=	byteorder.3socket	\
 		ethers.3socket		\
 		getaddrinfo.3socket	\
 		getifaddrs.3socket	\
 		getipnodebyname.3socket \
 		getnetbyname.3socket	\
-		getpeername.3socket	\
 		getprotobyname.3socket	\
 		getservbyname.3socket	\
-		getsockname.3socket	\
-		getsockopt.3socket	\
 		getsourcefilter.3socket \
 		icmp6_filter.3socket	\
 		if_nametoindex.3socket	\
 		inet6_opt.3socket	\
 		inet6_rth.3socket	\
-		listen.3socket		\
 		rcmd.3socket		\
-		recv.3socket		\
 		rexec.3socket		\
 		sctp_bindx.3socket	\
 		sctp_getladdrs.3socket	\
@@ -50,15 +42,9 @@
 		sctp_recvmsg.3socket	\
 		sctp_send.3socket	\
 		sctp_sendmsg.3socket	\
-		send.3socket		\
-		sockaddr.3socket	\
-		shutdown.3socket	\
-		socket.3socket		\
-		socketpair.3socket	\
 		spray.3socket
 
-MANLINKS=	accept4.3socket			\
-		endnetent.3socket		\
+MANLINKS=	endnetent.3socket		\
 		endprotoent.3socket		\
 		endservent.3socket		\
 		ether_aton.3socket		\
@@ -113,8 +99,6 @@
 		ntohll.3socket			\
 		ntohs.3socket			\
 		rcmd_af.3socket			\
-		recvfrom.3socket		\
-		recvmsg.3socket			\
 		rexec_af.3socket		\
 		rresvport.3socket		\
 		rresvport_af.3socket		\
@@ -121,23 +105,12 @@
 		ruserok.3socket			\
 		sctp_freeladdrs.3socket		\
 		sctp_freepaddrs.3socket		\
-		sendmsg.3socket			\
-		sendto.3socket			\
 		setipv4sourcefilter.3socket	\
 		setnetent.3socket		\
 		setprotoent.3socket		\
 		setservent.3socket		\
-		setsockopt.3socket		\
-		setsourcefilter.3socket		\
-		sockaddr_dl.3socket		\
-		sockaddr_in.3socket		\
-		sockaddr_in6.3socket		\
-		sockaddr_ll.3socket		\
-		sockaddr_storage.3socket	\
-		sockaddr_un.3socket
+		setsourcefilter.3socket
 
-accept4.3socket			:= LINKSRC = accept.3socket
-
 htonl.3socket			:= LINKSRC = byteorder.3socket
 htonll.3socket			:= LINKSRC = byteorder.3socket
 htons.3socket			:= LINKSRC = byteorder.3socket
@@ -186,8 +159,6 @@
 getservent_r.3socket		:= LINKSRC = getservbyname.3socket
 setservent.3socket		:= LINKSRC = getservbyname.3socket
 
-setsockopt.3socket		:= LINKSRC = getsockopt.3socket
-
 getipv4sourcefilter.3socket	:= LINKSRC = getsourcefilter.3socket
 setipv4sourcefilter.3socket	:= LINKSRC = getsourcefilter.3socket
 setsourcefilter.3socket		:= LINKSRC = getsourcefilter.3socket
@@ -216,9 +187,6 @@
 rresvport_af.3socket		:= LINKSRC = rcmd.3socket
 ruserok.3socket			:= LINKSRC = rcmd.3socket
 
-recvfrom.3socket		:= LINKSRC = recv.3socket
-recvmsg.3socket			:= LINKSRC = recv.3socket
-
 rexec_af.3socket		:= LINKSRC = rexec.3socket
 
 sctp_freeladdrs.3socket		:= LINKSRC = sctp_getladdrs.3socket
@@ -225,16 +193,6 @@
 
 sctp_freepaddrs.3socket		:= LINKSRC = sctp_getpaddrs.3socket
 
-sendmsg.3socket			:= LINKSRC = send.3socket
-sendto.3socket			:= LINKSRC = send.3socket
-
-sockaddr_dl.3socket		:= LINKSRC = sockaddr.3socket
-sockaddr_in.3socket		:= LINKSRC = sockaddr.3socket
-sockaddr_in6.3socket		:= LINKSRC = sockaddr.3socket
-sockaddr_ll.3socket		:= LINKSRC = sockaddr.3socket
-sockaddr_storage.3socket	:= LINKSRC = sockaddr.3socket
-sockaddr_un.3socket		:= LINKSRC = sockaddr.3socket
-
 .KEEP_STATE:
 
 include		$(SRC)/man/Makefile.man
